
/* $Header: Tty.h,v 1.1 89/07/05 15:35:43 hubbard Exp $ */

/*-
 * Tty.h --
 *	Public header for users of the TTY widget.
 *
 * Copyright (c) 1987 by the Regents of the University of California
 *
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  The University of California
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 *
 * Author: Adam deBoor, U.C. Berkeley.
 *
 * $Log:	Tty.h,v $
 * Revision 1.1  89/07/05  15:35:43  hubbard
 * Initial revision
 * 
 * 
 */

#ifndef _Tty_h
#define _Tty_h

/* Resources:

 Name		     Class		RepType		Default Value
 ----		     -----		-------		-------------
 background	     Background		pixel		White
 border		     BorderColor	pixel		Black
 borderWidth	     BorderWidth	int		1
 destroyCallback     Callback		Pointer		NULL
 displayPosition     TextPosition	int		0
 editType	     EditType		XtTextEditType	XttextRead
 enterCallback	     Callback		Pointer		NULL
 file		     File		String		NULL
 height		     Height		int		font height
 insertPosition	     TextPosition	int		0
 interruptCallback   Callback           Pointer         NULL
 leftMargin	     Margin		int		2
 mappedWhenManaged   MappedWhenManaged	Boolean		True
 prompt		     Prompt		String		none
 selectTypes	     SelectTypes	Pointer		(internal)
 selection	     Selection		Pointer		empty selection
 sensitive	     Sensitive		Boolean		True
 string		     String		String		NULL
 textOptions	     TextOptions	int		0
 width		     Width		int		100
 x		     Position		int		0
 y		     Position		int		0

*/
#define	XtNenterCallback    "enterCallback"
#define XtNinterruptCallback "interruptCallback"
#define XtNprompt 	    "prompt"
#define XtCPrompt 	    "Prompt"

typedef struct _TtyClassRec *TtyWidgetClass;
typedef struct _TtyRec	    *TtyWidget;
extern WidgetClass	    ttyWidgetClass;

extern void		    XtTtyPrompt();
extern void		    XtTtyPrintf();
extern void		    XtTtyPutString();

#endif _Tty_h
