
/* $Header: TtyP.h,v 1.1 89/07/05 15:35:45 hubbard Exp $ */

/*-
 * TtyP.h --
 *	Private header file for subclasses of the TTY widget.
 *
 * Copyright (c) 1987 by the Regents of the University of California
 *
 * Permission to use, copy, modify, and distribute this
 * software and its documentation for any purpose and without
 * fee is hereby granted, provided that the above copyright
 * notice appear in all copies.  The University of California
 * makes no representations about the suitability of this
 * software for any purpose.  It is provided "as is" without
 * express or implied warranty.
 *
 * Author: Adam deBoor, U.C. Berkeley.
 *
 * $Log:	TtyP.h,v $
 * Revision 1.1  89/07/05  15:35:45  hubbard
 * Initial revision
 * 
 * 
 */

#ifndef _TtyP_h
#define _TtyP_h

#include    "AsciiTextP.h"
#include    "Tty.h"

/* New class fields */
typedef struct { int empty; } TtyClassPart;

/* Class record (Note: Tty is a subclass of Text) */
typedef struct _TtyClassRec {
    CoreClassPart 	core_class;
    SimpleClassPart	simple_class;
    TextClassPart 	text_class;
    TtyClassPart  	tty_class;
} TtyClassRec;

extern TtyClassRec	ttyClassRec;

/* New instance fields */
typedef struct _TtyPart {
    XtCallbackList	enter;	    /* Text entered */
    XtCallbackList	interrupt;  /* Interrupt character typed */
    XtTextBlock	  	prompt;	    /* Prompt string */
    XtTextPosition	startPos;   /* Start of entered text */
    Boolean		prompted;   /* Prompt given (i.e. startPos valid) */
    XtTextPosition	markPos;    /* Position of mark */
} TtyPart;

/* Instance record */
typedef struct _TtyRec {
    CorePart	  core;
    SimplePart	  simple;
    TextPart	  text;
    TtyPart	  tty;
} TtyRec;

#endif _TtyP_h
