
#ifndef lint
static char rcsid[] = "$Header: autoexec.c,v 1.1 89/07/05 15:35:52 hubbard Exp $";
#endif

/*
 *
 *                     Copyright 1988, 1989
 *                  PCS Computer Systeme, GmbH
 *                     Munich, West Germany
 *
 *  All rights reserved.
 * 
 *  This is unsupported software and is subject to change without notice.
 *  PCS makes no representations about the suitability of this software
 *  for any purpose. It is supplied "as is" without express or implied
 *  warranty.
 * 
 *  Permission to use, copy, modify, and distribute this software and its
 *  documentation for any purpose and without fee is hereby granted, provided
 *  that the above copyright notice appear in all copies and that both that
 *  copyright notice and this permission notice appear in supporting
 *  documentation, and that the name of PCS Computer Systeme not be used in
 *  advertising or publicity pertaining to distribution of the software
 *  without specific, written prior permission.
 *
 */

/*
 * Author:	Jordan K. Hubbard
 * For:		PCS Computer Systems, GmbH.
 * When:	February 23rd, 1989.
 *
 * $Log:	autoexec.c,v $
 * Revision 1.1  89/07/05  15:35:52  hubbard
 * Initial revision
 * 
 * 
 */

#include "xgdb.h"

QUEUE_ENTRY(_exec_entry) BEGIN
     int type;		/* Type of auto-exec command */
     String cmd;	/* Command to exec */
     String contents;	/* Command output */
     Boolean enabled;   /* Enabled? */
IS_TYPE AutoExec;

static View *AutoExecView;

/*
 * Everything needed to handle the auto-exec pane.
 */

/*
 * Update the autoExec view.
 */
void autoExecUpdateView()
{}

void toggle_update()
{}

/*
 * Create the AutoExec view pane.
 */
void autoExecCreateView(w, client_data, data)
Widget w;
caddr_t client_data, data;
{
     static FormField buttons[] = {
	  { { "close", viewCloseShell },	2, FALSE, 0, 0, 0, 0 },
	  { { "update", autoExecUpdateView },	2, FALSE, 0, 8, 0, 1 },
	  { { "autoUpdate", toggle_update },	2, FALSE, 0, 2, 0, 2 },
	  { { NULL, NULL },			0, 0, 0, 0, 0, 0 },
     };
     FieldAttributes fla;
     Field *flist;
     String name = ((w) ? XtWidgetToName(w) : (String)data);

     Entry("autoExecCreateView");

     fprintf(stderr, "This view not implemented for Beta test.\n");
     Leave_void;

     /* NOTREACHED */
     if (!AutoExecView) {
	  convertFormToField(buttons, &flist);

	  ii = 0;
	  AutoExecView = viewCreateShell(name, flist,
					 vPanedWidgetClass,
					 aa, ii);
     }
     XtPopup(AutoExecView->parent, XtGrabNone);
     XRaiseWindow(XtDisplay(AutoExecView->parent),
		  XtWindow(AutoExecView->parent));
     AutoExecView->mapped = TRUE;

     /* Make the field that invoked us go insensitive */
     fla.sensitive = FALSE;
     changeField(nameToField(name, client_data),
		 FldSensitive, &fla);
     autoExecUpdateView();
     Leave_void;
}



