
/* $Header: messages.h,v 1.1 89/07/05 15:36:15 hubbard Exp $ */

/*
 *
 *                     Copyright 1988, 1989
 *                  PCS Computer Systeme, GmbH
 *                     Munich, West Germany
 *
 *  All rights reserved.
 * 
 *  This is unsupported software and is subject to change without notice.
 *  PCS makes no representations about the suitability of this software
 *  for any purpose. It is supplied "as is" without express or implied
 *  warranty.
 * 
 *  Permission to use, copy, modify, and distribute this software and its
 *  documentation for any purpose and without fee is hereby granted, provided
 *  that the above copyright notice appear in all copies and that both that
 *  copyright notice and this permission notice appear in supporting
 *  documentation, and that the name of PCS Computer Systeme not be used in
 *  advertising or publicity pertaining to distribution of the software
 *  without specific, written prior permission.
 *
 */

/*
 * Author:	Jordan K. Hubbard
 * For:		PCS Computer Systems
 * When:	April 18th, 1989.
 *
 * $Log:	messages.h,v $
 * Revision 1.1  89/07/05  15:36:15  hubbard
 * Initial revision
 * 
 * 
 */

#ifndef MESSAGES_H_INCLUDE
#define MESSAGES_H_INCLUDE

/* Field attribute types */
#define FldBorderWidth	0x1
#define FldSensitive	0x2
#define FldJustify	0x4
#define FldX		0x8
#define FldY		0x10
#define FldLabel	0x20
#define FldWidth	0x40
#define FldResizable	0x80
#define FldFromVert	0x100
#define FldFromHoriz	0x200
#define FldVertOffset	0x400
#define FldHorizOffset	0x800

#define SetSimpleFld(fld, n, f) \
     ( (fld).name = (String)(n), (fld).function = (VoidFuncP)(f) )

/*
 * Generic message utilities for popping up confirmation boxes, error
 * messages, etc.
 */

void yesOrNo(), popupErrorMessage(), createMenu(), popupMenu(),
     popdownMenu(), feep(), createFields(), changeField(), changeFields();

Field *convertSimpleToField(), *convertFormToField(), *nameToField();

#endif /* MESSAGES_H_INCLUDE */
