
/* $Header: queue.h,v 1.1 89/07/05 15:36:23 hubbard Exp $ */

/*
 *
 *                     Copyright 1988, 1989
 *                  PCS Computer Systeme, GmbH
 *                     Munich, West Germany
 *
 *  All rights reserved.
 * 
 *  This is unsupported software and is subject to change without notice.
 *  PCS makes no representations about the suitability of this software
 *  for any purpose. It is supplied "as is" without express or implied
 *  warranty.
 * 
 *  Permission to use, copy, modify, and distribute this software and its
 *  documentation for any purpose and without fee is hereby granted, provided
 *  that the above copyright notice appear in all copies and that both that
 *  copyright notice and this permission notice appear in supporting
 *  documentation, and that the name of PCS Computer Systeme not be used in
 *  advertising or publicity pertaining to distribution of the software
 *  without specific, written prior permission.
 *
 */

/*
 * Author:	Jordan K. Hubbard
 * For:		PCS Computer Systems
 * When:	April 18th, 1989.
 *
 * $Log:	queue.h,v $
 * Revision 1.1  89/07/05  15:36:23  hubbard
 * Initial revision
 * 
 * 
 */

#ifndef QUEUE_H_INCLUDE
#define QUEUE_H_INCLUDE

/*
 * Defines for the queue manipulation routines.
 */

#define QUEUE_ENTRY(ent)	\
     typedef struct ent {	\
	  struct ent *prev;	\
	  struct ent *next;

#define IS_TYPE }

#define BEGIN

#define NEXT(i)     ((i)->next)
#define PREV(i)     ((i)->prev)
#define FIRST(q, t) ((t *)((q)->head))
#define LAST(q, t)  ((t *)((q)->tail))
#define HEAD(q)     ((Link)((q)->head))
#define TAIL(q)     ((Link)((q)->tail))

#define FIFO	1
#define LIFO	2

/* Forward declarations */
void addQueueEntry(), removeQueueEntry(), replaceQueueEntry(),
     storeEventQueue(), restoreEventQueue();

GenericPtr popQueueEntry();
Boolean queueActive(), queueEmpty(), entryOnQueue();

#endif /* QUEUE_H_INCLUDE */
