
/* $Header: regparse.h,v 1.1 89/07/05 15:36:33 hubbard Exp $ */

/*
 *
 *                     Copyright 1988, 1989
 *                  PCS Computer Systeme, GmbH
 *                     Munich, West Germany
 *
 *  All rights reserved.
 * 
 *  This is unsupported software and is subject to change without notice.
 *  PCS makes no representations about the suitability of this software
 *  for any purpose. It is supplied "as is" without express or implied
 *  warranty.
 * 
 *  Permission to use, copy, modify, and distribute this software and its
 *  documentation for any purpose and without fee is hereby granted, provided
 *  that the above copyright notice appear in all copies and that both that
 *  copyright notice and this permission notice appear in supporting
 *  documentation, and that the name of PCS Computer Systeme not be used in
 *  advertising or publicity pertaining to distribution of the software
 *  without specific, written prior permission.
 *
 */

/*
 * Author:	Jordan K. Hubbard
 * For:		PCS Computer Systems
 * When:	April 18th, 1989.
 *
 * $Log:	regparse.h,v $
 * Revision 1.1  89/07/05  15:36:33  hubbard
 * Initial revision
 * 
 * 
 */

#ifndef REGPARSE_H_INCLUDE
#define REGPARSE_H_INCLUDE

/*
 * Anything on the parser queue should use these to simplify arg
 * declaration and checking.
 */
#define P_ARGS	p, s, len
#define P_ARG_DECL Process *p; String s; int *len
#define P_CHECKARGS if (!p) puke("%p: Passed NULL process\n"); \
     else if (!s || *len <= 0) Leave((String)NULL)

/* Parser handlers should use one of the following */
#define T_PROC_ARGS	P_ARGS
#define T_PROC_DECL	Process *p; String s; int len
#define T_PROCS_ARGS 	p, s, regs
#define T_PROCS_DECL	Process *p; String s; struct re_registers *regs

/* Simple parser types */
#define T_ARG		1
#define T_ARGS		2
#define T_PROC		3
#define T_PROCS		4
#define T_PROC0 	5
#define T_NOP		6
#define T_BOOL		7

/*
 * Public routines in the regular expression parser support code.
 */

String parseSimpleList();
void initializeRegexps();

RegEnt *find_regexp_entry();

#endif /* REGPARSE_H_INCLUDE */
