
/* $Header: stubs.h,v 1.1 89/07/05 15:36:45 hubbard Exp $ */

/*
 *
 *                     Copyright 1988, 1989
 *                  PCS Computer Systeme, GmbH
 *                     Munich, West Germany
 *
 *  All rights reserved.
 * 
 *  This is unsupported software and is subject to change without notice.
 *  PCS makes no representations about the suitability of this software
 *  for any purpose. It is supplied "as is" without express or implied
 *  warranty.
 * 
 *  Permission to use, copy, modify, and distribute this software and its
 *  documentation for any purpose and without fee is hereby granted, provided
 *  that the above copyright notice appear in all copies and that both that
 *  copyright notice and this permission notice appear in supporting
 *  documentation, and that the name of PCS Computer Systeme not be used in
 *  advertising or publicity pertaining to distribution of the software
 *  without specific, written prior permission.
 *
 */

/*
 * Author:	Jordan K. Hubbard
 * For:		PCS Computer Systems
 * When:	April 18th, 1989.
 *
 * $Log:	stubs.h,v $
 * Revision 1.1  89/07/05  15:36:45  hubbard
 * Initial revision
 * 
 * 
 */

#ifndef STUBS_H_INCLUDE
#define STUBS_H_INCLUDE

/*
 * These functions must be provided for every debugger, whether or not
 * the actually do anything. (If you want to stick as close to the
 * current model as possible, that is).
 */

void processDebuggerOutput(), handleDebuggerTermination();
void setDebuggerArgs(), setInitialDebuggerState();

void sendToDebugger(), interruptDebugger(), redirectOutput();
void queueDebuggerSend();

/*
 * Forward declarations for the interface functions. These consitute the
 * "Debugger dependant" part of xgdb and I would be happy to see most people
 * use this command set as a base when writing support for other debuggers.
 * Unsupported commands might be emulated by spawning off appropriate unix
 * processes and/or faking it. All in all, I feel that gdb has the best
 * command set available and it would be nice if xgdb could have the same
 * appearance regardless of the underlying debugger. Whether or not this
 * design is robust enough to make such possible remains to be seen.
 */

/* Commands */
void debuggerRun(), debuggerContinue(),	debuggerKill(),	debuggerStep(),
     debuggerStepThrough(), debuggerStepI(), debuggerStepIThrough(),
     debuggerStepUntil(), debuggerStepFinish(), debuggerUp(), debuggerDown(),
     debuggerFrame(), debuggerAddBkpt(), debuggerDeleteBkpt(),
     debuggerClearBkpt(), debuggerEnableBkpt(), debuggerDisableBkpt(),
     debuggerSearchForward(), debuggerSearchBackward(), debuggerExecFile(),
     debuggerSymbolFile(), debuggerCoreFile(), debuggerChangeDirectory(),
     debuggerSetDirectory(), debuggerSetTTY(), debuggerRedirectOutput(),
     debuggerSetFrame();


/* Query functions */
void debuggerQueryStatus(), debuggerQueryBreakpoints();
void debuggerQueryInitialSource(), debuggerQueryStack();

#endif /* STUBS_H_INCLUDE */

