
/* $Header: views.h,v 1.1 89/07/05 15:37:05 hubbard Exp $ */

/*
 *
 *                     Copyright 1988, 1989
 *                  PCS Computer Systeme, GmbH
 *                     Munich, West Germany
 *
 *  All rights reserved.
 * 
 *  This is unsupported software and is subject to change without notice.
 *  PCS makes no representations about the suitability of this software
 *  for any purpose. It is supplied "as is" without express or implied
 *  warranty.
 * 
 *  Permission to use, copy, modify, and distribute this software and its
 *  documentation for any purpose and without fee is hereby granted, provided
 *  that the above copyright notice appear in all copies and that both that
 *  copyright notice and this permission notice appear in supporting
 *  documentation, and that the name of PCS Computer Systeme not be used in
 *  advertising or publicity pertaining to distribution of the software
 *  without specific, written prior permission.
 *
 */

/*
 * Author:	Jordan K. Hubbard
 * For:		PCS Computer Systems
 * When:	April 18th, 1989.
 *
 * $Log:	views.h,v $
 * Revision 1.1  89/07/05  15:37:05  hubbard
 * Initial revision
 * 
 * 
 */

#ifndef VIEWS_H_INCLUDE
#define VIEWS_H_INCLUDE

/*
 * All the public entry points for various "views" into the debugger's
 * environment.
 */


/* These are generic to all views */

/* create */
void assemblyCreateView(), autoExecCreateView(), breakCreateView(),
     sourceCreateView(), stackCreateView(), statusCreateView();

/* update */
void assemblyUpdateView(), autoExecUpdateView(), breakUpdateView(),
     registerUpdateView(), sourceUpdateView(), stackUpdateView(),
     statusUpdateView(), updateAllViews();

/* mapped? */
Boolean assemblyMapped(), autoExecMapped(), breakMapped(),
     registerMapped(), sourceMapped(), stackMapped(),
     statusMapped();
        

/* Non-generic entry points for modification/query of view contents */

/* assembly */
String assemblyDisplayFunction();

/* break */
void breakAddBreakpoint(), breakDeleteBreakpoint(), breakEnableBreakpoint(),
     breakDisableBreakpoint(), breakDeleteBreakpoints();

/* stack */
void stackHandleFrame();

/* source */
void sourceNoLineInfo();

#endif /* VIEWS_H_INCLUDE */
